/*
 * Log related functions/defines.
 *
 * Copyright (C) 2011  Simon Ruderich
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "tlsproxy.h"
#include "log.h"

/* va_*() */
#include <stdarg.h>
/* pthread_*() */
#include <pthread.h>


void log_message(int level, const char *format, ...) {
    va_list ap;
    const char *level_string;

    if (global_log_level < level) {
        return;
    }

    switch (level) {
        case LOG_ERROR:   level_string = "ERROR"; break;
        case LOG_WARNING: level_string = "WARN "; break;
        case LOG_DEBUG:   level_string = "DEBUG"; break;
        default:          level_string = "UNKNOWN";
    }

    va_start(ap, format);
    fprintf(stdout, "[%s] [%d] ", level_string, (int)pthread_self());
    vfprintf(stdout, format, ap);
    fprintf(stdout, "\n");
    va_end(ap);
}
